extractedData <- read.delim("./DataExtractionCollaborative.txt", header = TRUE, quote = "\"", dec = ".", fill = TRUE, comment.char = "", na.strings = "n_i")

Var1Label <- "Number of built-in communication tools"
Var2Label <- "Number of external communication tools"
bubbleScaler <- 1.15
fileName <- "../papers/journalPaper/figures/communication_means.pdf"

Var1ColumnValues <- c("0", "1", "2", "3", "4")
Var2ColumnValues <-  c("0", "1", "2", "3", "4")

Var1 <- c("0", "1", "2", "3", "4", "5", "0", "1", "2", "3", "4", "5", "0", "1", "2", "3", "4", "5", "0", "1", "2", "3", "4", "5", "0", "1", "2", "3", "4", "5")
Var2 <- c("0", "0", "0", "0", "0", "0", "1", "1", "1", "1", "1", "1", "2", "2", "2", "2", "2", "2", "3", "3", "3", "3", "3", "3", "4", "4", "4", "4", "4", "4")
count <- c(15, 11, 5, 7, 2, 0, 0, 2, 1, 0, 0, 0, 3, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)


#######################################################################

countOccurrences <- function(el1, el2) {
  sum <- 0
  for(i in 1:length(Elements1)) {
      if((Elements1[i] == el1) && (Elements2[i] == el2)) {
        sum <- sum + 1
      }
  }
  sum
}

grid <- data.frame(Var1, Var2, count)

# we remove all the rows with 0 value as count
grid <- grid[grid$count != "0", ]

new_row <- c(5, 3, 0)
new_row2 <- c(5, 4, 0)

grid <- rbind(grid, new_row, new_row2)

# here we start creating the plot

library(ggplot2)
grid$radius <- sqrt( grid$count / pi ) * bubbleScaler

p <- ggplot(na.omit(grid),aes(Var1,Var2)) +
  #geom_point(aes(size=radius*10),shape=21,fill="white", alpha=0.8)+
  geom_point(data=grid,aes(fill=count,size=radius*13),shape=21,color="black", alpha=0.9) +
  scale_fill_gradient2(low="green", high="grey", limit=c(0,max(grid$count)),name=Var2Label) +
  geom_text(aes(label=count),size=7, alpha=1)+
  guides(fill=FALSE)+
  #geom_text(aes(label=count),size=5, alpha=1,vjust=3,hjust=-2)+
  scale_size_identity()+
  #expand_limits(y=c(0,1,2,3,4)) +
  theme_bw() +
  theme(panel.grid.major = element_line(colour = "grey")) + 
  labs(x=Var1Label, y=Var2Label) +
  theme(axis.text.x = element_text(size=20, angle=0, hjust=0.5, vjust=0), axis.text.y = element_text(size=20),
  axis.title.x = element_text(size=20), axis.title.y = element_text(size=20))
  #scale_y_continuous(labels=Var2ColumnValues) +
  #scale_x_discrete(limits=c(0, 1)) 
  

print(p)
ggsave(fileName, p, width=3, height=2, units="in", scale=3)

