# we read the tab-delimited textual file
data <- read.delim("./DataExtractionCollaborative.txt", header = TRUE, sep = "\t", quote = "\"",
                   dec = ".", fill = TRUE, comment.char = "", na.strings = "n_i")

# the name of the column that we want to inspect and the tag that we want to count
column <- "Workspace.awareness"
tags <- c("UpEd", "Ntf")
tagNames <- c("Updates", "Notifications")

prefix <- "P"
separator <- ", "

getPrimaryList <- function(currentTag) {
  return(paste(paste(prefix, subset(data, grepl(currentTag, data[[column]]))$ID, "", sep=""), collapse=separator))
}

getPrimaryOccurrences <- function(currentTag) {
  return(length(subset(data, grepl(currentTag, data[[column]]))$ID))
}

getTableLine <- function(currentTag, currentName) {
  currentList <- getPrimaryList(currentTag)
  return(paste("\\textit{", currentName, "} & \\databar{", getPrimaryOccurrences(currentTag), "} & ", currentList, "  \\\\ % ", currentTag, "\n", sep=""))
}

# we print the table
result <- ""
for(i in 1:length(tags)) {
  result <- paste(result, getTableLine(tags[i], tagNames[i]));
}

writeLines(result)




